#!/bin/sh


case $1 in

	start)
		#kill all
		killall openvpn pppd pptpd xl2tpd
		killall -9 openvpn pppd pptpd xl2tpd
		kill -HUP `cat /usr/local/AppCentral/vpn-server/freeradius/var/run/radiusd/radiusd.pid`
		kill -KILL `cat /usr/local/AppCentral/vpn-server/freeradius/var/run/radiusd/radiusd.pid`
		rm /usr/local/AppCentral/vpn-server/etc/openvpn/status.log
		# insmod
		/etc/script/vpn.sh insmod
		modprobe nf_nat_ipv4
		modprobe iptable_nat
		modprobe nf_nat_masquerade_ipv4
		sysctl -w net.ipv4.ip_forward=1
		# pptpctrl soft link
		mkdir -p /usr/local/sbin
		ln -s /usr/local/AppCentral/vpn-server/bin/pptpctrl /usr/local/sbin/pptpctrl
		#auth-up/down soft link for log
		mkdir -p /etc/ppp
		ln -s /usr/local/AppCentral/vpn-server/bin/auth-up /etc/ppp/auth-up
		ln -s /usr/local/AppCentral/vpn-server/bin/auth-down /etc/ppp/auth-down
		# open winbindd and set doamin
		/usr/builtin/etc/init.d/S49winbindd start
		sed -i s/--domain=.*\ --request-nt-key/--domain=`uname -n`\ --request-nt-key/ /usr/local/AppCentral/vpn-server/freeradius/etc/raddb/modules/mschap
		# start freeradius
		ln -s /volume0/usr/builtin/lib/samba/libtalloc.so.2 /usr/local/AppCentral/vpn-server/freeradius/lib
		/usr/local/AppCentral/vpn-server/freeradius/sbin/radiusd
		# set iptables
		iptables -t nat --flush
		LAN=`cat /usr/local/AppCentral/vpn-server/etc/vpnserver.config | grep ^\\\[general -A1 | sed 1d | awk '{print $NF}'`
		ETH=`cat /etc/nas.conf | grep ^\\\[$LAN -A1 | sed 1d | awk '{print $NF}'`
		iptables -t nat -A POSTROUTING -o $ETH -j MASQUERADE
		iptables -A INPUT -p tcp --dport 1723 -j ACCEPT
		iptables -A INPUT -p 47 -j ACCEPT
		# disable vpn client
		touch /volume0/usr/builtin/etc/vpnclient/disable
		#kernel module for ipsec
		for i in tunnel4.ko tunnel6.ko xfrm4_mode_beet.ko xfrm4_mode_transport.ko xfrm4_mode_tunnel.ko xfrm6_mode_beet.ko xfrm6_mode_transport.ko \
                 xfrm6_mode_tunnel.ko xfrm6_tunnel.ko xfrm_algo.ko xfrm_user.ko xt_policy.ko xfrm_ipcomp.ko xfrm4_tunnel.ko af_key.ko ah6.ko \
                 esp6.ko ipcomp.ko ipcomp6.ko xfrm4_tunnel.ko ah4.ko esp4.ko authenc.ko echainiv.ko udp_tunnel.ko ip6_udp_tunnel.ko l2tp_core.ko \
				 l2tp_core.ko pppox.ko l2tp_ppp.ko
		do
				insmod /lib/modules/`uname -r`/$i
		done
		#start server
		/usr/local/AppCentral/vpn-server/bin/vpninit
		#start strongswan
		/usr/local/AppCentral/vpn-server/strongswan/sbin/ipsec start
		;;

	stop)
		#remove pptpctrl softlink
		rm -f /usr/local/sbin/pptpctrl
		#remove auth-up/down softlink
		rm -f /etc/ppp/auth-up
		rm -f /etc/ppp/auth-down
		#enable vpnclient
		rm -f /volume0/usr/builtin/etc/vpnclient/disable
		#stop process
		killall openvpn pppd pptpd xl2tpd
		killall -9 openvpn pppd pptpd xl2tpd
		kill -HUP `cat /usr/local/AppCentral/vpn-server/freeradius/var/run/radiusd/radiusd.pid`
		kill -KILL `cat /usr/local/AppCentral/vpn-server/freeradius/var/run/radiusd/radiusd.pid`
		rm /usr/local/AppCentral/vpn-server/etc/openvpn/status.log
		#remove ipsec kernel module
		for i in esp4.ko ah4.ko xfrm4_tunnel.ko ipcomp6.ko ipcomp.ko esp6.ko ah6.ko af_key.ko xfrm4_tunnel.ko xfrm_ipcomp.ko xt_policy.ko xfrm_user.ko \
                 xfrm_algo.ko xfrm6_tunnel.ko xfrm6_mode_tunnel.ko xfrm6_mode_transport.ko xfrm6_mode_beet.ko xfrm4_mode_tunnel.ko \
                 xfrm4_mode_transport.ko xfrm4_mode_beet.ko tunnel6.ko tunnel4.ko 
		do
				insmod /lib/modules/`uname -r`/$i
		done
		#remove iptables
		LAN=`cat /usr/local/AppCentral/vpn-server/etc/vpnserver.config | grep ^\\\[general -A1 | sed 1d | awk '{print $NF}'`
		ETH=`cat /etc/nas.conf | grep ^\\\[$LAN -A1 | sed 1d | awk '{print $NF}'`
		iptables -t nat -D POSTROUTING -o $ETH -j MASQUERADE
		iptables -D INPUT -p tcp --dport 1723 -j ACCEPT
		iptables -D INPUT -p 47 -j ACCEPT
		#stop strongswan
		/usr/local/AppCentral/vpn-server/strongswan/sbin/ipsec stop
		;;

	reload)
		;;
		
	*)
		echo "usage: $0 {start|stop|reload}"
		exit 1
		;;
		
esac
exit 0
