/* Copyright (c) 2011 Asustor Inc. All rights reserved. */

Ext.define('AS.ARC.apps.vpnServer.fn', {
	extend: 'AS.ARC.apps._fn'
});

Ext.define('AS.ARC.apps.vpnServer.page', {
	extend: 'AS.ARC.apps._page'
});

Ext.define('AS.ARC.apps.vpnServer.main', {
	extend: 'AS.ARC._appLeftSelectorRightTabPanel',
	appTag: 'vpn-server',
	title: _S('VPN_SERVER', 'VPN_SERVER'),
    appConfig: {
		"module": "AS.ARC.apps.vpnServer.main",
		"fnJs": [
			"overview.js",
            "log.js",
            "privilege.js",
			"settings.js",
		]
	},
    
	// Not support functions
	notSupportFns: [],
	
	createWindow: function () {
		var appMain = this,
			desktop = this.core.getDesktop(),
			win = desktop.getWindow(this.id);
        this.menus = [
            [_S('VPN_SERVER', 'OVERVIEW'), 'overview'],
            [_S('SYSTEMINFORMATION', 'FN_LOG'), 'log'],
            [_S('COMMON', 'PRIVILEGE'), 'privilege'],
			[ _S('COMMON', 'SETTINGS'), 'settings'],
        ];
        
		if (!win) {
			win = desktop.createWindow({
				app: this,
				id: this.id,
				title: this.title,
				animCollapse: false,
				border: false,
				layout: 'fit',
				tools: [],
				items: [{
					itemId: 'main',
                    layout: 'border',
					border: false,
					items: [{
						region: 'west',
						itemId: 'selector',
						cls: 'as-selector-panel',
						split: true,
                        maxWidth: 300,
                        minWidth: 50,
						items: [
							this.getSelectorConfig()
						]
					}, {
						xtype: 'panel',
						itemId: 'container',
						layout: 'card',
						region: 'center',
						cls: 'as-function-panel',
						activeItem: 0,
						items: this.getFnPanels()
					}]
				}]
			});
			
			this.win = win;
		}
		
		return win;
	}
});